=== modified file 'lib/lp/services/mail/incoming.py'
--- lib/lp/services/mail/incoming.py	2011-05-27 15:19:53 +0000
+++ lib/lp/services/mail/incoming.py	2011-05-30 23:57:16 +0000
@@ -50,13 +50,11 @@
     )
 from canonical.launchpad.webapp.interfaces import IPlacelessAuthUtility
 from canonical.librarian.interfaces import UploadFailed
-from lp.app.errors import NotFoundError
 from lp.registry.interfaces.person import IPerson
 from lp.services.features import getFeatureFlag
 from lp.services.mail.handlers import mail_handlers
 from lp.services.mail.sendmail import do_paranoid_envelope_to_validation
 from lp.services.mail.signedmessage import signed_message_from_string
-from lp.services.messages.interfaces.message import IMessageSet
 
 # Match '\n' and '\r' line endings. That is, all '\r' that are not
 # followed by a '\n', and all '\n' that are not preceded by a '\r'.
@@ -426,16 +424,6 @@
 
     log.debug('processing mail from %r message-id %r' %
         (mail['from'], mail['message-id']))
-    msg_set = getUtility(IMessageSet)
-    try:
-        msg_set.get(mail['message-id'])
-    except NotFoundError:
-        pass
-    else:
-        log.warning(
-            'Message with id %s already stored.  Skipping.',
-            mail['message-id'])
-        return None
 
     # If the Return-Path header is '<>', it probably means
     # that it's a bounce from a message we sent.

=== modified file 'lib/lp/services/mail/tests/__init__.py'
--- lib/lp/services/mail/tests/__init__.py	2011-05-27 15:31:46 +0000
+++ lib/lp/services/mail/tests/__init__.py	2011-05-30 23:57:16 +0000
@@ -1,32 +0,0 @@
-# Copyright 2011 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-"""Tests for mail services."""
-
-__metaclass__ = type
-__all__ = ['ListHandler']
-
-
-from contextlib import contextmanager
-
-from lp.services.mail.handlers import mail_handlers
-
-
-class ListHandler:
-    """A mail handler that simply adds the message to a list."""
-    def __init__(self):
-        self.processed = []
-
-    def process(self, signed_msg, to_addr, filealias=None, log=None):
-        self.processed.append(signed_msg)
-        return True
-
-
-@contextmanager
-def active_handler(domain, handler):
-    """In the context, the specified handler is registered for the domain."""
-    mail_handlers.add(domain, handler)
-    try:
-        yield handler
-    finally:
-        del mail_handlers._handlers[domain]

=== modified file 'lib/lp/services/mail/tests/test_incoming.py'
--- lib/lp/services/mail/tests/test_incoming.py	2011-05-27 15:19:53 +0000
+++ lib/lp/services/mail/tests/test_incoming.py	2011-05-30 23:57:16 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009, 2011 Canonical Ltd.  This software is licensed under the
+# Copyright 2009 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 from doctest import DocTestSuite
@@ -6,11 +6,7 @@
 import os
 import unittest
 
-from testtools.matchers import (
-    Equals,
-    Is,
-    MatchesRegex,
-    )
+from testtools.matchers import Equals, Is
 import transaction
 from zope.security.management import setSecurityPolicy
 
@@ -28,17 +24,11 @@
     authenticateEmail,
     extract_addresses,
     handleMail,
-    handle_one_mail,
     MailErrorUtility,
     ORIGINAL_TO_HEADER,
     )
 from lp.services.mail.sendmail import MailController
 from lp.services.mail.stub import TestMailer
-from lp.services.messages.model.message import MessageSet
-from lp.services.mail.tests import (
-    active_handler,
-    ListHandler,
-    )
 from lp.testing import TestCaseWithFactory
 from lp.testing.factory import GPGSigningContext
 from lp.testing.mail_helpers import pop_notifications
@@ -132,25 +122,6 @@
         mail = self.factory.makeSignedMessage(email_address=email)
         self.assertThat(authenticateEmail(mail), Is(None))
 
-    def test_handle_one_mail_duplicate_message_id(self):
-        # An incoming mail with the message-id of an already-processed mail is
-        # skipped.
-        orig_message = self.factory.makeMessage()
-        handler_calls = []
-        self.assertEqual([], handler_calls)
-        duplicate_mail = self.factory.makeSignedMessage(
-            msgid=orig_message.rfc822msgid,
-            to_address='new@random.example.com')
-        log = BufferLogger()
-        with active_handler('random.example.com', ListHandler()) as handler:
-            handle_one_mail(log, duplicate_mail, None, None, None)
-        self.assertEqual([], handler.processed)
-        messages = MessageSet().get(orig_message.rfc822msgid)
-        self.assertEqual(1, len(messages))
-        matches = MatchesRegex(
-            '(.|\n)*WARNING Message with id .* already stored.  Skipping.')
-        self.assertThat(log.getLogBuffer(), matches)
-
 
 class TestExtractAddresses(TestCaseWithFactory):
 

